unit LTR41_UNIT_TEST;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,  ltrapidefine, ltrapitypes, ltrapi,ltr41api;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox2: TComboBox;
    GroupBox2: TGroupBox;
    Splitter1: TSplitter;
    GroupBox3: TGroupBox;
    ComboBox3: TComboBox;
    Button2: TButton;
    CheckBox1: TCheckBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    ComboBox10: TComboBox;
    ComboBox11: TComboBox;
    ComboBox12: TComboBox;
    Button4: TButton;
    GroupBox4: TGroupBox;
    Edit1: TEdit;
    Label3: TLabel;
    CheckBox2: TCheckBox;
    Memo1: TMemo;
    Timer1: TTimer;
    Edit2: TEdit;
    Edit3: TEdit;
    Timer2: TTimer;
    CheckBox5: TCheckBox;
    Timer5: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer5Timer(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  STTR=^string;
var
  Form1: TForm1;
  LTRONLINE:bool;
  LTR41ONLINE:bool;
  LTR:TLTR;
  CSNLIST:array[0..CRATE_MAX-1,0..SERIAL_NUMBER_SIZE-1]of char;
  CrateNom   :byte;
  CrateSelect:byte;
  Total41:byte;
  LIST41:array[0..MODULE_MAX-1]of byte;
  LTR41SELECT:byte;
  LTR41:TLTR41;
  err:integer;
  DATA_BUF :array[0..200000]of cardinal;
  TMARK_BUF:array[0..200000]of cardinal;
  GODCounter:integer;
implementation

{$R *.dfm}

function IntTohexchar(Val:integer;N:byte):byte;
begin
       Val:=(Val shr (N*4))and $F;
       if val<10 then IntTohexchar:=48+val else IntTohexchar:=55+val;
end;


function TESTERROR(ERROR:integer;MEMO:Tmemo;STR:string):boolean;
begin
  TESTERROR:=false;
  if(memo.lines.Count>10000)then memo.Lines.Clear;
  if(ERROR<LTR_OK)then
  begin
     Memo.Lines.Add( STR+' :  '+ Inttostr(ERROR));
     TESTERROR:=true;
  end
  else
  begin
     Memo.Lines.Add( STR+' :  ');
  end
end;
procedure TForm1.Button1Click(Sender: TObject);
var i:byte;
    S:String;
    MID:array[0..MODULE_MAX-1]of WORD;
begin
  //  41-,   .
  if LTR41ONLINE then
  begin
     LTR41_Close(@LTR41);
  end;
  //  LTR,   .
  if LTRONLINE then
  begin
     err:=LTR_Close(@LTR);
     if TESTERROR(err,memo1,'  ')then exit;

     LTRONLINE:=false;
  end;
  //       (LocalHost 127.0.0.1)
    for i:=0 to CRATE_MAX-1 do CSNLIST[i]:='';
    LTR_Init(@LTR);
    err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  ')then exit;
    err:=LTR_GetCrates(@LTR,@CSNLIST[0,0]); if TESTERROR(err,memo1,'    ')then exit;
    err:=LTR_Close(@LTR);                   if TESTERROR(err,memo1,'  ')then exit;
    //  
    CrateNom:=0;
    CrateSelect:=0;
    Combobox1.Items.Clear;
    For i:=0 to CRATE_MAX-1 do
    if(CSNLIST[i]<>'')then
    begin
       Combobox1.Items.Add(CSNLIST[i]);
       CrateNom:=CrateNom+1;
    end;
    Combobox1.ItemIndex:=CrateSelect;
  //    
  LTR_Init(@LTR);
  for i:=0 to SERIAL_NUMBER_SIZE-1 do
  LTR.csn[i]:=CSNLIST[CrateSelect][i];

  err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  ')then exit;
  err:=LTR_GetCrateModules(@LTR,@MID[0]); if TESTERROR(err,memo1,'   ')then exit;
  Total41:=0;
  //  
  Combobox2.Items.Clear;
  for i:=0 to MODULE_MAX-1 do
    if MID[i]=MID_LTR41 then
    begin
       Combobox2.Items.Add(IntToStr(i));
       LIST41[Total41]:=i;
       Total41:=Total41+1;
    end;
   LTR41SELECT:=0;
   Combobox2.ItemIndex:=LTR41SELECT;
  //   
  LTR41_Init(@LTR41);
  err:=LTR41_Open(@LTR41,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST41[LTR41SELECT]+1);
  if TESTERROR(err,memo1,'  ')then
  begin
     Groupbox2.Visible:=false;
     if(err<>-10)then exit else
     begin
       Groupbox2.Visible:=true;
       LTR41ONLINE:=true;
     end;
  end
  else
  begin
    Groupbox2.Visible:=true;
    LTR41ONLINE:=true;
  end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //  41-,   .
  if LTR41ONLINE then
  begin
     LTR41_Close(@LTR41);
  end;
  //  LTR,   .
  if LTRONLINE then
  begin
     err:=LTR_Close(@LTR);
     if TESTERROR(err,memo1,'  ')then exit;
     LTRONLINE:=false;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var i:byte;
    S:String;
    MID:array[0..MODULE_MAX-1]of WORD;
begin
 //  41-,   .
  if LTR41ONLINE then
  begin
     LTR41_Close(@LTR41);
  end;
  CrateSelect:=Combobox1.ItemIndex;
  //    
  LTR_Init(@LTR);
  for i:=0 to SERIAL_NUMBER_SIZE-1 do
  LTR.csn[i]:=CSNLIST[CrateSelect][i];
  err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  ')then exit;
  err:=LTR_GetCrateModules(@LTR,@MID[0]); if TESTERROR(err,memo1,'    41')then exit;
  Total41:=0;
  //  
  Combobox2.Items.Clear;
  for i:=0 to MODULE_MAX-1 do
    if MID[i]=MID_LTR41 then
    begin
       Combobox2.Items.Add(IntToStr(i));
       LIST41[Total41]:=i;
       Total41:=Total41+1;
    end;
   LTR41SELECT:=0;
   Combobox2.ItemIndex:=LTR41SELECT;
  //   
  LTR41_Init(@LTR41);
  err:=LTR41_Open(@LTR41,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST41[LTR41SELECT]+1);
  if TESTERROR(err,memo1,'  41')then
  begin
     Groupbox2.Visible:=false;
     exit;
  end
  else
  begin
    Groupbox2.Visible:=true;
    LTR41ONLINE:=true;
  end;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
 //  41-,   .
  if LTR41ONLINE then
  begin
     LTR41_Close(@LTR41);
  end;
  LTR41SELECT:=Combobox2.ItemIndex;
  //   
  LTR41_Init(@LTR41);
  err:=LTR41_Open(@LTR41,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST41[LTR41SELECT]+1);
  if TESTERROR(err,memo1,'  41')then 
  begin
     Groupbox2.Visible:=false;
     exit;
  end
  else
  begin
    Groupbox2.Visible:=true;
    LTR41ONLINE:=true;
  end;
end;
//  .
procedure TForm1.Button2Click(Sender: TObject);
begin
    LTR41.Marks.StartMark_Mode:=Combobox3.ItemIndex;
    LTR41.Marks.SecondMark_Mode:=Combobox4.ItemIndex;
    err:=LTR41_Config(@LTR41);
    if TESTERROR(err,memo1,'  41')then exit;
    err:=LTR41_MakeStartMark(@LTR41);
    if TESTERROR(err,memo1,'   ')then exit
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    if(Checkbox1.Checked)
    then
      begin
        LTR41.Marks.StartMark_Mode:=Combobox3.ItemIndex;
        LTR41.Marks.SecondMark_Mode:=Combobox4.ItemIndex;
        LTR41_Config(@LTR41);
        if TESTERROR(err,memo1,'  41')then exit;
        LTR41_StartSecondMark(@LTR41);
        if TESTERROR(err,memo1,'   ""')then exit

      end
    else
      begin
        LTR41_StopSecondMark(@LTR41);
        if TESTERROR(err,memo1,'   ')then exit
      end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var DATA:integer;
begin
end;

procedure TForm1.Button4Click(Sender: TObject);
var DATA:integer;
begin

    err:=LTR41_Config(@LTR41);
    if TESTERROR(err,memo1,'  41')then exit;
    err:=LTR41_ReadPort(@LTR41,@DATA);
    if TESTERROR(err,memo1,'  ')then exit;
    ComboBox12.ItemIndex:=(DATA shr 28)and $F;
    ComboBox11.ItemIndex:=(DATA shr 24)and $F;
    ComboBox10.ItemIndex:=(DATA shr 20)and $F;
    ComboBox9.ItemIndex:= (DATA shr 16)and $F;
    ComboBox8.ItemIndex:= (DATA shr 12)and $F;
    ComboBox7.ItemIndex:= (DATA shr  8)and $F;
    ComboBox6.ItemIndex:= (DATA shr  4)and $F;
    ComboBox5.ItemIndex:=  DATA and $F;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
    if checkbox2.Checked then
    begin //  

        LTR41.StreamReadRate:=strtoint(edit1.Text);
        err:=LTR41_Config(@LTR41);
        if TESTERROR(err,memo1,'  41')then exit;
        GODCounter:=0;
        LTR41_StartStreamRead(@LTR41);
        Timer2.Enabled:=true;
        edit1.Text:=floattostr(LTR41.StreamReadRate);
    end else
    begin //  

        Timer2.Enabled:=false;
        LTR41_StopStreamRead(@LTR41);
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var DATA:integer;
begin
if(LTR41ONLINE)then
begin
   DATA:=LTR41.Channel.tmark;
   Edit2.Text:=IntToStr(DATA SHR 16);
   Edit3.Text:=IntToStr(DATA and $FFFF);
end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var erRr:integer;
    i:integer;
    f:textFile;
    TMARK_STR:string;
    //DATA_BUF :array[0..20000]of cardinal;
    //TMARK_BUF:array[0..20000]of cardinal;
begin
  for i:=0 to 20000 do
  begin
   TMARK_BUF[i]:=0;
   DATA_BUF[i]:=0;
  end;

  erRr:=LTR41_Recv(@LTR41,@DATA_BUF,@TMARK_BUF,strToint(Edit1.text),20000);
  GODCounter:=GODCounter+erRr;
  TESTERROR(err,memo1,'   : '+inttostr(erRr)+'.   '+' : '+inttostr(GODCounter)+'.');
  if(erRr<strToint(Edit1.text))then
  begin
    Memo1.Lines.Add(' :     !');
    Memo1.Lines.Add(' :                       ');
    for i:=erRr-16 to erRr+16 do
    begin
       TMARK_STR:=char(IntTohexchar(TMARK_BUF[i],7))+char(IntTohexchar(TMARK_BUF[i],6))+char(IntTohexchar(TMARK_BUF[i],5))+char(IntTohexchar(TMARK_BUF[i],4))+char(IntTohexchar(TMARK_BUF[i],3))+char(IntTohexchar(TMARK_BUF[i],2))+char(IntTohexchar(TMARK_BUF[i],1))+char(IntTohexchar(TMARK_BUF[i],0));
       Memo1.Lines.Add('  '+Inttostr(GODCounter+i)+'    '+Inttostr(i)+'     :     '+char(IntTohexchar(DATA_BUF[i],7))+char(IntTohexchar(DATA_BUF[i],6))+char(IntTohexchar(DATA_BUF[i],5))+char(IntTohexchar(DATA_BUF[i],4))+char(IntTohexchar(DATA_BUF[i],3))+char(IntTohexchar(DATA_BUF[i],2))+char(IntTohexchar(DATA_BUF[i],1))+char(IntTohexchar(DATA_BUF[i],0))+'       '+TMARK_STR);
    end;

    Timer2.Enabled:=false;
    LTR41_StopStreamRead(@LTR41);
  end;

  err:=LTR41_ProcessData(@LTR,@DATA_BUF,@TMARK_BUF,@erRr);
  TESTERROR(err,memo1,' :   '+inttostr(erRr));
  if(err=-4046)then
  begin
    Memo1.Lines.Add(':   '+inttostr(err)+'    :'+ inttostr(erRr)+' :');
    for i:=0 to 2001 do
    begin
      TMARK_STR:=char(IntTohexchar(TMARK_BUF[i],7))+char(IntTohexchar(TMARK_BUF[i],6))+char(IntTohexchar(TMARK_BUF[i],5))+char(IntTohexchar(TMARK_BUF[i],4))+char(IntTohexchar(TMARK_BUF[i],3))+char(IntTohexchar(TMARK_BUF[i],2))+char(IntTohexchar(TMARK_BUF[i],1))+char(IntTohexchar(TMARK_BUF[i],0));
      Memo1.Lines.Add(':'+inttostr(i)+'  '+char(IntTohexchar(DATA_BUF[i],7))+char(IntTohexchar(DATA_BUF[i],6))+char(IntTohexchar(DATA_BUF[i],5))+char(IntTohexchar(DATA_BUF[i],4))+char(IntTohexchar(DATA_BUF[i],3))+char(IntTohexchar(DATA_BUF[i],2))+char(IntTohexchar(DATA_BUF[i],1))+char(IntTohexchar(DATA_BUF[i],0))+'     MARK:  '+TMARK_STR);
    end;
    Timer2.Enabled:=false;
    LTR41_StopStreamRead(@LTR41);
  end;


end;

procedure TForm1.Timer5Timer(Sender: TObject);
var DATA:integer;
begin
    err:=LTR41_ReadPort(@LTR41,@DATA);
    if TESTERROR(err,memo1,'  ')then
    begin
        Memo1.Lines.Add('!!!     !!!');
        Timer5.Enabled:=false;
        Checkbox5.Checked:=false;
    end;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  if checkbox5.Checked then
  begin
    Timer5.Enabled:=true;
  end else
  begin
    Timer5.Enabled:=false;
  end;
end;

end.
